jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 1 | #!/bin/bash |
| 2 | # |
| 3 | # Copyright (C) 2007 The Android Open Source Project |
| 4 | # |
| 5 | # Licensed under the Apache License, Version 2.0 (the "License"); |
| 6 | # you may not use this file except in compliance with the License. |
| 7 | # You may obtain a copy of the License at |
| 8 | # |
| 9 | # http://www.apache.org/licenses/LICENSE-2.0 |
| 10 | # |
| 11 | # Unless required by applicable law or agreed to in writing, software |
| 12 | # distributed under the License is distributed on an "AS IS" BASIS, |
| 13 | # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. |
| 14 | # See the License for the specific language governing permissions and |
| 15 | # limitations under the License. |
| 16 | |
| 17 | # Set up prog to be the path of this script, including following symlinks, |
| 18 | # and set up progdir to be the fully-qualified pathname of its directory. |
| 19 | prog="$0" |
| 20 | while [ -h "${prog}" ]; do |
| 21 | newProg=`/bin/ls -ld "${prog}"` |
| 22 | newProg=`expr "${newProg}" : ".* -> \(.*\)$"` |
| 23 | if expr "x${newProg}" : 'x/' >/dev/null; then |
| 24 | prog="${newProg}" |
| 25 | else |
| 26 | progdir=`dirname "${prog}"` |
| 27 | prog="${progdir}/${newProg}" |
| 28 | fi |
| 29 | done |
| 30 | oldwd=`pwd` |
| 31 | progdir=`dirname "${prog}"` |
| 32 | cd "${progdir}" |
| 33 | progdir=`pwd` |
| 34 | prog="${progdir}"/`basename "${prog}"` |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 35 | test_dir="test-$$" |
| 36 | tmp_dir="/tmp/${test_dir}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 37 | |
| 38 | export JAVA="java" |
Elliott Hughes | 9829e33 | 2013-03-21 12:38:10 -0700 | [diff] [blame] | 39 | export JAVAC="javac -g -source 1.5 -target 1.5" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 40 | export RUN="${progdir}/etc/push-and-run-test-jar" |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 41 | export DEX_LOCATION=/data/run-test/${test_dir} |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 42 | export NEED_DEX="true" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 43 | |
Tsu Chiang Chuang | 4407e61 | 2012-07-19 16:13:43 -0700 | [diff] [blame] | 44 | # If dx was not set by the environment variable, assume it is in the path. |
| 45 | if [ -z "$DX" ]; then |
| 46 | export DX="dx" |
| 47 | fi |
| 48 | |
Tsu Chiang Chuang | 6674f8a | 2013-01-16 15:41:21 -0800 | [diff] [blame] | 49 | # If jasmin was not set by the environment variable, assume it is in the path. |
| 50 | if [ -z "$JASMIN" ]; then |
| 51 | export JASMIN="jasmin" |
| 52 | fi |
| 53 | |
| 54 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 55 | info="info.txt" |
| 56 | build="build" |
| 57 | run="run" |
| 58 | expected="expected.txt" |
| 59 | output="output.txt" |
| 60 | build_output="build-output.txt" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 61 | lib="libartd.so" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 62 | run_args="--quiet" |
| 63 | |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 64 | target_mode="yes" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 65 | dev_mode="no" |
| 66 | update_mode="no" |
| 67 | debug_mode="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 68 | runtime="art" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 69 | usage="no" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 70 | build_only="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 71 | |
| 72 | while true; do |
| 73 | if [ "x$1" = "x--host" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 74 | target_mode="no" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 75 | RUN="${progdir}/etc/host-run-test-jar" |
TDYa127 | b92bcab | 2012-04-08 00:09:51 -0700 | [diff] [blame] | 76 | DEX_LOCATION=$tmp_dir |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 77 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 78 | elif [ "x$1" = "x--jvm" ]; then |
Brian Carlstrom | 2613de4 | 2012-06-15 17:37:16 -0700 | [diff] [blame] | 79 | target_mode="no" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 80 | runtime="jvm" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 81 | RUN="${progdir}/etc/reference-run-test-classes" |
Elliott Hughes | c717eef | 2012-06-15 16:01:26 -0700 | [diff] [blame] | 82 | NEED_DEX="false" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 83 | shift |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 84 | elif [ "x$1" = "x-O" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 85 | lib="libart.so" |
| 86 | shift |
| 87 | elif [ "x$1" = "x--dalvik" ]; then |
| 88 | lib="libdvm.so" |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 89 | runtime="dalvik" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 90 | shift |
| 91 | elif [ "x$1" = "x--image" ]; then |
| 92 | shift |
| 93 | image="$1" |
| 94 | run_args="${run_args} --image $image" |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 95 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 96 | elif [ "x$1" = "x--debug" ]; then |
| 97 | run_args="${run_args} --debug" |
| 98 | shift |
| 99 | elif [ "x$1" = "x--gdb" ]; then |
| 100 | run_args="${run_args} --gdb" |
| 101 | dev_mode="yes" |
| 102 | shift |
| 103 | elif [ "x$1" = "x--zygote" ]; then |
| 104 | run_args="${run_args} --zygote" |
| 105 | shift |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 106 | elif [ "x$1" = "x--interpreter" ]; then |
| 107 | run_args="${run_args} --interpreter" |
| 108 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 109 | elif [ "x$1" = "x--no-verify" ]; then |
| 110 | run_args="${run_args} --no-verify" |
| 111 | shift |
| 112 | elif [ "x$1" = "x--no-optimize" ]; then |
| 113 | run_args="${run_args} --no-optimize" |
| 114 | shift |
| 115 | elif [ "x$1" = "x--no-precise" ]; then |
| 116 | run_args="${run_args} --no-precise" |
| 117 | shift |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 118 | elif [ "x$1" = "x--invoke-with" ]; then |
| 119 | shift |
| 120 | what="$1" |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 121 | if [ "x$what" = "x" ]; then |
| 122 | echo "$0 missing argument to --invoke-with" 1>&2 |
| 123 | usage="yes" |
| 124 | break |
| 125 | fi |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 126 | run_args="${run_args} --invoke-with ${what}" |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 127 | shift |
| 128 | elif [ "x$1" = "x--dev" ]; then |
| 129 | run_args="${run_args} --dev" |
| 130 | dev_mode="yes" |
| 131 | shift |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 132 | elif [ "x$1" = "x--build-only" ]; then |
| 133 | build_only="yes" |
| 134 | shift |
| 135 | elif [ "x$1" = "x--output-path" ]; then |
| 136 | shift |
| 137 | tmp_dir=$1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 138 | if [ "x$tmp_dir" = "x" ]; then |
| 139 | echo "$0 missing argument to --output-path" 1>&2 |
| 140 | usage="yes" |
| 141 | break |
| 142 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 143 | shift |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 144 | elif [ "x$1" = "x--update" ]; then |
| 145 | update_mode="yes" |
| 146 | shift |
| 147 | elif [ "x$1" = "x--help" ]; then |
| 148 | usage="yes" |
| 149 | shift |
| 150 | elif expr "x$1" : "x--" >/dev/null 2>&1; then |
Elliott Hughes | 7c04610 | 2011-10-19 18:16:03 -0700 | [diff] [blame] | 151 | echo "unknown $0 option: $1" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 152 | usage="yes" |
| 153 | break |
| 154 | else |
| 155 | break |
| 156 | fi |
| 157 | done |
| 158 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 159 | if [ ! "$runtime" = "jvm" ]; then |
| 160 | run_args="${run_args} --lib $lib" |
| 161 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 162 | |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 163 | if [ "$runtime" = "dalvik" ]; then |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 164 | if [ "$target_mode" = "no" ]; then |
| 165 | framework="${OUT}/system/framework" |
| 166 | bpath="${framework}/core.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/core-junit.jar:${framework}/bouncycastle.jar:${framework}/ext.jar" |
| 167 | run_args="${run_args} --boot -Xbootclasspath:${bpath}" |
| 168 | else |
| 169 | true # defaults to using target BOOTCLASSPATH |
| 170 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 171 | elif [ "$runtime" = "art" ]; then |
| 172 | if [ "$target_mode" = "no" ]; then |
Brian Carlstrom | 4353486 | 2014-02-19 01:13:52 -0800 | [diff] [blame] | 173 | # ANDROID_BUILD_TOP and ANDROID_HOST_OUT are not set in a build environment. |
| 174 | if [ -z "$ANDROID_BUILD_TOP" ]; then |
| 175 | export ANDROID_BUILD_TOP=$oldwd |
| 176 | fi |
| 177 | if [ -z "$ANDROID_HOST_OUT" ]; then |
| 178 | export ANDROID_HOST_OUT=$ANDROID_BUILD_TOP/out/host/linux-x86 |
| 179 | fi |
Jeff Hao | 201803f | 2013-11-20 18:11:39 -0800 | [diff] [blame] | 180 | run_args="${run_args} --boot -Ximage:${ANDROID_HOST_OUT}/framework/core.art" |
| 181 | else |
| 182 | run_args="${run_args} --boot -Ximage:/data/art-test/core.art" |
| 183 | fi |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 184 | fi |
| 185 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 186 | if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then |
| 187 | echo "--dev and --update are mutually exclusive" 1>&2 |
| 188 | usage="yes" |
| 189 | fi |
| 190 | |
| 191 | if [ "$usage" = "no" ]; then |
| 192 | if [ "x$1" = "x" -o "x$1" = "x-" ]; then |
| 193 | test_dir=`basename "$oldwd"` |
| 194 | else |
| 195 | test_dir="$1" |
| 196 | fi |
| 197 | |
| 198 | if [ '!' -d "$test_dir" ]; then |
| 199 | td2=`echo ${test_dir}-*` |
| 200 | if [ '!' -d "$td2" ]; then |
| 201 | echo "${test_dir}: no such test directory" 1>&2 |
| 202 | usage="yes" |
| 203 | fi |
| 204 | test_dir="$td2" |
| 205 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 206 | # Shift to get rid of the test name argument. The rest of the arguments |
| 207 | # will get passed to the test run. |
| 208 | shift |
| 209 | fi |
| 210 | |
| 211 | if [ "$usage" = "yes" ]; then |
| 212 | prog=`basename $prog` |
| 213 | ( |
| 214 | echo "usage:" |
| 215 | echo " $prog --help Print this message." |
| 216 | echo " $prog [options] [test-name] Run test normally." |
| 217 | echo " $prog --dev [options] [test-name] Development mode" \ |
| 218 | "(dumps to stdout)." |
| 219 | echo " $prog --update [options] [test-name] Update mode" \ |
| 220 | "(replaces expected.txt)." |
| 221 | echo ' Omitting the test name or specifying "-" will use the' \ |
| 222 | "current directory." |
| 223 | echo " Runtime Options:" |
Brian Carlstrom | fa42b44 | 2013-06-17 12:53:45 -0700 | [diff] [blame] | 224 | echo " -O Run non-debug rather than debug build (off by default)." |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 225 | echo " --debug Wait for a debugger to attach." |
Ian Rogers | 4c1bf1a | 2012-12-11 10:44:28 -0800 | [diff] [blame] | 226 | echo " --gdb Run under gdb; incompatible with some tests." |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 227 | echo " --build-only Build test files only (off by default)." |
jeffhao | 0dff3f4 | 2012-11-20 15:13:43 -0800 | [diff] [blame] | 228 | echo " --interpreter Enable interpreter only mode (off by default)." |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 229 | echo " --no-verify Turn off verification (on by default)." |
| 230 | echo " --no-optimize Turn off optimization (on by default)." |
| 231 | echo " --no-precise Turn off precise GC (on by default)." |
| 232 | echo " --zygote Spawn the process from the Zygote." \ |
| 233 | "If used, then the" |
| 234 | echo " other runtime options are ignored." |
| 235 | echo " --host Use the host-mode virtual machine." |
Ian Rogers | 0e03367 | 2013-04-19 10:22:46 -0700 | [diff] [blame] | 236 | echo " --invoke-with Pass --invoke-with option to runtime." |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 237 | echo " --dalvik Use Dalvik (off by default)." |
Elliott Hughes | 58bcc40 | 2012-02-14 14:10:10 -0800 | [diff] [blame] | 238 | echo " --jvm Use a host-local RI virtual machine." |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 239 | echo " --output-path [path] Location where to store the build" \ |
| 240 | "files." |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 241 | ) 1>&2 |
| 242 | exit 1 |
| 243 | fi |
| 244 | |
| 245 | cd "$test_dir" |
| 246 | test_dir=`pwd` |
| 247 | |
| 248 | td_info="${test_dir}/${info}" |
| 249 | td_expected="${test_dir}/${expected}" |
| 250 | |
Brian Carlstrom | 22469aa | 2012-09-07 10:34:57 -0700 | [diff] [blame] | 251 | if [ ! -r $td_info ]; then |
| 252 | echo "${test_dir}: missing file $td_info" 1>&2 |
| 253 | exit 1 |
| 254 | fi |
| 255 | |
| 256 | if [ ! -r $td_expected ]; then |
| 257 | echo "${test_dir}: missing file $td_expected" 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 258 | exit 1 |
| 259 | fi |
| 260 | |
| 261 | # copy the test to a temp dir and run it |
| 262 | |
Elliott Hughes | 510c878 | 2011-10-06 10:57:34 -0700 | [diff] [blame] | 263 | echo "${test_dir}: building..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 264 | |
| 265 | rm -rf "$tmp_dir" |
| 266 | cp -Rp "$test_dir" "$tmp_dir" |
| 267 | cd "$tmp_dir" |
| 268 | |
| 269 | if [ '!' -r "$build" ]; then |
| 270 | cp "${progdir}/etc/default-build" build |
| 271 | fi |
| 272 | |
| 273 | if [ '!' -r "$run" ]; then |
| 274 | cp "${progdir}/etc/default-run" run |
| 275 | fi |
| 276 | |
| 277 | chmod 755 "$build" |
| 278 | chmod 755 "$run" |
| 279 | |
Elliott Hughes | 8cbc8bc | 2011-10-04 11:19:45 -0700 | [diff] [blame] | 280 | export TEST_NAME=`basename ${test_dir}` |
| 281 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 282 | good="no" |
| 283 | if [ "$dev_mode" = "yes" ]; then |
| 284 | "./${build}" 2>&1 |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 285 | build_exit="$?" |
| 286 | echo "build exit status: $build_exit" 1>&2 |
| 287 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 288 | echo "${test_dir}: running..." 1>&2 |
| 289 | "./${run}" $run_args "$@" 2>&1 |
Brian Carlstrom | dc959ea | 2013-10-28 00:44:49 -0700 | [diff] [blame] | 290 | run_exit="$?" |
Brian Carlstrom | 700c8d3 | 2012-11-05 10:42:02 -0800 | [diff] [blame] | 291 | echo "run exit status: $run_exit" 1>&2 |
| 292 | if [ "$run_exit" = "0" ]; then |
| 293 | good="yes" |
| 294 | fi |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 295 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 296 | elif [ "$update_mode" = "yes" ]; then |
| 297 | "./${build}" >"$build_output" 2>&1 |
| 298 | build_exit="$?" |
| 299 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 300 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 301 | "./${run}" $run_args "$@" >"$output" 2>&1 |
| 302 | sed -e 's/[[:cntrl:]]$//g' < "$output" >"${td_expected}" |
| 303 | good="yes" |
| 304 | else |
| 305 | cat "$build_output" 1>&2 |
| 306 | echo "build exit status: $build_exit" 1>&2 |
| 307 | fi |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 308 | elif [ "$build_only" = "yes" ]; then |
| 309 | good="yes" |
| 310 | "./${build}" >"$build_output" 2>&1 |
| 311 | build_exit="$?" |
| 312 | if [ "$build_exit" '!=' '0' ]; then |
| 313 | cp "$build_output" "$output" |
| 314 | echo "build exit status: $build_exit" >>"$output" |
| 315 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 316 | if [ "$?" '!=' "0" ]; then |
| 317 | good="no" |
| 318 | echo "BUILD FAILED For ${TEST_NAME}" |
| 319 | fi |
| 320 | fi |
Tsu Chiang Chuang | 379e2f5 | 2013-08-20 12:24:52 -0700 | [diff] [blame] | 321 | # Clean up extraneous files that are not used by tests. |
Tsu Chiang Chuang | 0160d99 | 2013-09-13 14:17:42 -0700 | [diff] [blame] | 322 | find $tmp_dir -mindepth 1 ! -regex ".*/\(.*jar\|$output\|$expected\)" | xargs rm -rf |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 323 | exit 0 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 324 | else |
| 325 | "./${build}" >"$build_output" 2>&1 |
| 326 | build_exit="$?" |
| 327 | if [ "$build_exit" = '0' ]; then |
Elliott Hughes | 2bfc673 | 2012-11-27 20:40:51 -0800 | [diff] [blame] | 328 | echo "${test_dir}: running..." 1>&2 |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 329 | "./${run}" $run_args "$@" >"$output" 2>&1 |
| 330 | else |
| 331 | cp "$build_output" "$output" |
| 332 | echo "build exit status: $build_exit" >>"$output" |
| 333 | fi |
| 334 | diff --strip-trailing-cr -q "$expected" "$output" >/dev/null |
| 335 | if [ "$?" = "0" ]; then |
| 336 | # output == expected |
| 337 | good="yes" |
| 338 | echo "${test_dir}: succeeded!" 1>&2 |
| 339 | fi |
| 340 | fi |
| 341 | |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 342 | # Clean up test files. |
| 343 | if [ "$good" == "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 344 | cd "$oldwd" |
| 345 | rm -rf "$tmp_dir" |
Elliott Hughes | 7ab3a2a | 2012-06-18 16:34:20 -0700 | [diff] [blame] | 346 | if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 347 | adb shell rm -r $DEX_LOCATION |
| 348 | fi |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 349 | exit 0 |
| 350 | fi |
| 351 | |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 352 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 353 | ( |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 354 | if [ "$update_mode" != "yes" ]; then |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 355 | echo "${test_dir}: FAILED!" |
| 356 | echo ' ' |
| 357 | echo '#################### info' |
| 358 | cat "${td_info}" | sed 's/^/# /g' |
| 359 | echo '#################### diffs' |
| 360 | diff --strip-trailing-cr -u "$expected" "$output" |
| 361 | echo '####################' |
| 362 | echo ' ' |
| 363 | fi |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 364 | echo "${TEST_NAME} files left in ${tmp_dir} on host" |
Tsu Chiang Chuang | 011fade | 2012-07-09 18:34:47 -0700 | [diff] [blame] | 365 | if [ "$target_mode" == "yes" ]; then |
Brian Carlstrom | 105215d | 2012-06-14 12:50:44 -0700 | [diff] [blame] | 366 | echo "and in ${DEX_LOCATION} on target" |
| 367 | fi |
| 368 | |
jeffhao | 5d1ac92 | 2011-09-29 17:41:15 -0700 | [diff] [blame] | 369 | ) 1>&2 |
| 370 | |
| 371 | exit 1 |